import * as React from 'react';
import styles from './App001.module.scss';
import { IApp001Props } from './IApp001Props';
import { escape } from '@microsoft/sp-lodash-subset';
import {
  SPHttpClient,
  SPHttpClientResponse,
  IHttpClientOptions
 // HttpClientResponse,
 // ISPHttpClientOptions 
} from '@microsoft/sp-http';

 //import * as pnp from 'sp-pnp-js';

//import { parse } from 'json2csv';
const { parse } = require('json2csv');

export default class App001 extends React.Component<IApp001Props, {}> {
  public render(): React.ReactElement<IApp001Props> {
    const {
    //  description
    } = this.props;

  //  this.getDropDown1();
  //  this.getDropDown2();
  //  this.getDropDown3('');
  //  this.getDropDown4();
  //  this.getDropDown5();
    this.getUserStore();  

    const IMG1: string = this.props.context.pageContext.web.absoluteUrl+"/SiteAssets/bwm_001.jpg";
   // const IMG2: string = this.props.context.pageContext.web.absoluteUrl+"/SiteAssets/SP-Reports.png";

    return (
      <div className={styles.SpFxCrud}>
        <div className={styles.container}>
            <div className={styles.row}>     
        {/*  <div className={styles.row}  style={{ backgroundImage: `url(${IMG2})`, height: '71px', width: '1200px' }}> */}        
            <div className={styles.column}>
             
                <table className={styles.tb1}>
                <tr>
                <td><img src={IMG1} height={35} alt="?"></img>
                </td>
                <td> <p className={styles.description}>{escape(this.props.description)}</p>  </td>
                <td className={styles.spacer}>  &nbsp; </td>
                <td className={styles.spacer}>  &nbsp; </td>
                <td>
                <div id="btn1" className={styles.tab1}>
                   <span className={styles.label} onClick={() => this.showScreen('1')}>Get User</span>
                </div>
                </td>
                <td>
                <div id="btn2" className={styles.tab2}>
                   <span className={styles.label} onClick={() => this.showScreen('2')}>Call API</span>
                </div>
                </td>
                <td>
                <div id="btn4" className={styles.tab2}>
                  <span className={styles.label} onClick={() => this.showScreen('4')}>SQL Queries </span>
                </div> 
                </td>
                
                <td>
                <div id="btn5" className={styles.tab2}>
                  <span className={styles.label} onClick={() => this.showScreen('5')}>  ZAP Where Used  </span> 
                </div> 
                </td>
                <td>
                <div id="btn6" className={styles.tab2}>
                  <span className={styles.label} onClick={() => this.showScreen('6')}>  ZAP Portal  </span> 
                </div> 
                </td>
                
                <td>
                <div id="btn3" className={styles.tab2}>
                  <span className={styles.label} onClick={() => this.showScreen('3')}>Audit </span>
                </div> 
                </td>
                <td>
                <div id="btn7" className={styles.tab2}>
                  <span className={styles.label} onClick={() => this.showScreen('7')}>Upload </span>
                </div> 
                </td>
                <td>
                <div id="btn8" className={styles.tab2}>
                  <span className={styles.label} onClick={() => this.showScreen('8')}>File </span>
                </div> 
                </td>
                <td>
                <div id="btn9" className={styles.tab2}>
                  <span className={styles.label} onClick={() => this.showScreen('9')}>  Zira API  </span> 
                </div> 
                </td>
                </tr>

                </table>   
             </div>   
            
          </div>
          <div className={styles.row}>         
            <div className={styles.column}>
            <table>
          
              <tr>
                <td colSpan={2} className={styles.description2}> Name: {escape(this.props.context.pageContext.user.displayName)}</td>
                <td className={styles.spacer}>  &nbsp; </td>
                <td className={styles.description2}> User ID: {escape(this.props.context.pageContext.user.loginName)}</td>
                <td className={styles.description2}>&nbsp; Dept:</td> <td> <input id="userDEPT" size={3} type="text" readOnly disabled className={styles.txhdg} /></td>
                <td className={styles.description2}>&nbsp; Store:</td> <td> <input id="userSTORE" size={6} type="text" readOnly disabled className={styles.txhdg} /></td>
                </tr>
                </table>

            </div>
          </div>

          <div className={styles.row}>         
            <div className={styles.column}>

              <div id="Div001" className={styles.Div001}>
               <div className={styles.div1}>
     
                 {/* ------------------------------------------------- 
                  <div className={(styles.button,styles.hidden1)}>
                  <span className={styles.label} onClick={this.getReport}>Submit</span> 
                  </div>
                                                
                  <div className={(styles.button)}>
                  <span className={styles.label} onClick={this.insertNew}>Copy</span>
                  </div>

                  <div className={(styles.button,styles.hidden1)}>
                  <span className={styles.label} onClick={this.getCURL}>cURL</span> 
                  </div>  
                     ------------------------------------------------- */}



                  <div>         
                  <input type="text" id="UID1"  size={30}  className={styles.txone} placeholder={escape(this.props.context.pageContext.user.loginName)}></input> 
                  </div>
                </div> 
           
            <div className={styles.div1}>
                  <div className={styles.button}>
                  <span className={styles.label} onClick={this.getUserProfile}>Get User</span> 
                  </div>   
                  <div className={styles.button}>
                  <span className={styles.label} onClick={this.listAllUsers}>List All Users</span> 
                  </div>  
             </div>               
           </div>  {/*  END OF Div001 */}


           <div id="Div002" className={styles.Div002}>
              <div className={styles.div1}>
                  <div>     
                  <select id="inAPI"  className={styles.txtwo}>
                  <option value="1">Item Lookup</option>
                  <option value="2">Fiscal Calendar</option>
                  <option value="3">Store Lookup</option>
                  <option value="4">Call Stored Procedure</option>
                  </select>  
                  &nbsp; 
                  <input type="text" size={8} id="inCUST" className={styles.txtwo} placeholder='Store'></input>
                  &nbsp;
                  <input id="inDT" type="date" className={styles.txone} />
                  &nbsp;
                  <input type="text" size={5} id="inFYPD" className={styles.txtwo} placeholder='FYPD'></input>
                  &nbsp;
                  </div>
           
                  <p>
                  
                  <button id="btn" className={styles.button} disabled={false} onClick={this.getApi}>Call API</button>
                  
               
                  {/* 
                   <button id="btn" className={styles.button} onClick={this.getApi}>Call API</button>
                    <div className={styles.button} >
                   <span id="btn" className={styles.label} onClick={this.getApi}>Call API</span> 
                   </div>
                    */}
                  <div className={styles.button2}>
                  <span className={styles.label} onClick={this.fetch1}>Call via Post</span> 
                  </div>
                  &nbsp;
                  <input type="checkbox" id="inCSV"></input>.CSV
                  <div className={styles.button2}>
                  <span className={styles.label} onClick={this.csvDownload}>Download</span> 
                  </div>
                  
                  <a href="#" onClick={()=>this.testLink1('hello')}>Click here</a>
                  </p>
              </div>
          </div> {/*  END OF Div002 */}
   

          <div id="Div003" className={styles.Div003}>
              <div className={styles.div1}>
                  <div>
                  <select id="ddAUDIT"  className={styles.txone}>
                  <option value="1">Date</option>
                  <option value="2">User</option>
                  <option value="3">Report Name</option>
                  </select>
                  </div> 
              </div>
              <div className={styles.div1}>                     
                  <div className={styles.button}>
                  <span className={styles.label} onClick={this.getAuditTrail}>Run</span> 
                  </div>
              </div>
         </div> {/*  END OF Div003 */}
         
         <div id="Div004" className={styles.Div004}>
              <div className={styles.div1}>
                  <div>
                  <input type="text" size={1} id="inID" readOnly disabled  className={styles.txone}></input>
                  &nbsp;
                  <input type="text" size={25} id="inTITLE" className={styles.txone}></input>
                  <p>
                  <textarea id="inSQL" rows={3} cols={60} className={styles.ta1}></textarea>
                  </p>
                  </div> 
              </div>
              <p>  
              <div className={styles.div1}>                     
                  <div className={styles.button}>
                  <span className={styles.label} onClick={this.processChanges}>Select</span> 
                  </div>
                  <div className={styles.button}>
                  <span className={styles.label} onClick={this.fetch3}>Save</span> 
                  </div>
                  <div className={styles.button}>
                  <span className={styles.label} onClick={this.fetch4}>Add New</span> 
                  </div>
                  <div className={styles.button}>
                  <span className={styles.label} onClick={this.fetch5}>Delete</span> 
                  </div>
                  <div  className={styles.button2}>
                  <span className={styles.label} onClick={() => this.showScreen('4')}>Refresh </span>
                  </div>            
              </div>
              </p>
         </div> {/*  END OF Div004 */}
        
         <div id="Div005" className={styles.Div005}>
              <div className={styles.div1}>
                  <b>ZAP: &nbsp; </b>     
                  <input type="hidden" size={5} id="inZAP" className={styles.txtwo} value=""></input>
                  <select id="inFLD0"  className={styles.txtwo}>
                  <option value="%">ALL</option>
                  <option value="Production" selected>Production</option>
                  <option value="Development">Development</option>
                  <option value="AX Analytics">AX Analytics</option>
                  <option value="Common">Common</option>
                  <option value="%Supporting%">Supporting</option>
                  </select> 
                  &nbsp;
                  <b> REPORT:</b>
                  &nbsp;
                  <input type="text" size={20} id="inFLD3" className={styles.txtwo} placeholder='Report Name%'></input>   
                  
                   &nbsp;
                  <input type="text" size={30} id="inFLD1" className={styles.txtwo} placeholder='%Search Key%'></input>   
                  &nbsp;
                  <input type="text" size={15} id="inFLD2" className={styles.txtwo} placeholder='%Search Key%'></input>
                 
              <p>
                
                  <button id="btnZAP" value="27" className={styles.button} onClick={this.getApi}>Search</button>   
                  
                  <div  className={styles.button2}>
                  <span className={styles.label} onClick={() => this.showScreen('5')}>Refresh </span>
                  </div> 
                  <div className={styles.button2}>
                  <span className={styles.label} onClick={this.csvDownload}>Download</span> 
                  </div>
                  <input type="checkbox" id="inZLIST"></input>Report Listing 
              </p>
              </div>
              
         </div>  {/*  END OF Div005 */}

         <div id="Div006" className={styles.Div006}>
                <div className={styles.div1}> 
                  <div className={styles.button3}>
                  <span className={styles.label}>ZAP Reporting & Analytics Portal</span> 
                  </div>
                </div>
                   
         </div>   {/*  END OF Div006 */}
         
         <div id="Div007" className={styles.Div007}>
                <div className={styles.div1}> 
                  <input type="file" name="readfile" id="readfile" />
                  <span  className={styles.button} onClick={this.getUploadFile}> Upload </span> 

                     <div id="btnUpload1">
                         <span  className={styles.button} onClick={this.saveToMySQL}> Save to MySQL </span>
                     </div> 
                     <div id="btnUpload2">
                         <span  className={styles.button} onClick={this.getUploadReport}> Refresh </span>
                     </div> 
                     <div id="btnUpload1">
                         <span  className={styles.button} onClick={this.readBLOB}> Read BLOB </span>
                     </div> 
                </div>
                   
         </div>   {/*  END OF Div007 */}
         
         <div id="Div008" className={styles.Div007}>
                <div className={styles.div1}> 
                  <input type="file" name="readfile2" id="readfile2" />
                  <span  className={styles.button} onClick={this.getUploadFile2}> Upload </span> 

                     <div id="btnUpload1">
                         <span  className={styles.button} onClick={this.saveToSPDIR}> Save to SP Directory </span>
                     </div> 
                </div>
                   
         </div>   {/*  END OF Div008 */}
         
         <div id="Div009" className={styles.Div007}>
             <p> Nothing to see hear? </p>
                   
         </div>   {/*  END OF Div009 */}

         </div>
         </div>

            <div className={styles.row}>          
               <div className={styles.column}>
          
                  <div><input type="text" id='MSG1' size={77} disabled className={styles.MSG1} value="Enter a User ID to view the AAD Directory Information"></input>
                  <p></p>
                  </div>
              
                  <div id="allItems" className={styles.tb2}></div>  
            
               </div>
            </div>
         
        </div>
      </div>

    );
   
  }

//----------------------------------------------------------------------------  
// Show/Hide Menus and Screens.
//---------------------------------------------------------------------------- 
private showScreen = (n: any): void => { 
   //alert('N: ' + n)

   // Hide all Screens
   var nbr_of_divs = 9;  // Total plus 1
   var i = 0;
   for (i = 1; i < nbr_of_divs; i++) { 
       var DIV1 = "Div00"+i;
       var BTN1 = "btn"+i;
      // alert('I: ' + i + ' ' + DIV1 + ' ' + BTN1)
       var e1 = (document.getElementById(DIV1));  e1.style.display  = 'none';
       document.getElementById(BTN1).style.color="#333333";
       document.getElementById(BTN1).style.backgroundColor="#fffffa";
   };
 
   // Set active screen visible
   var DIV1 = "Div00"+n;
   var BTN1 = "btn"+n;
  // alert('N: ' + i + ' ' + DIV1 + ' ' + BTN1)
   var e1 = (document.getElementById(DIV1));  e1.style.display  = 'block';
   document.getElementById(BTN1).style.color="#000000";
   document.getElementById(BTN1).style.backgroundColor="#87cefa";
  // document.getElementById(BTN1).style.backgroundColor="#AD9DDF";


   // Reset defaults
  // alert("HELLO");
   (document.getElementById("btn")  as HTMLInputElement).removeAttribute("disabled");
   (document.getElementById("btnZAP")  as HTMLInputElement).removeAttribute("disabled");
   document.getElementById("allItems").innerHTML = "";

   var MSG1 = [];
   MSG1[1] = `Enter a User ID to view the AAD Directory Information`;
   MSG1[2] = `Select a Report and Enter Key values.  Click on "Call API" to process.`;  
   MSG1[3] = `Choose a Report Type and click on "Run" to process.`; 
   MSG1[4] = `*** Please wait. Query List is Loading ***`; 
   MSG1[5] = `Enter search criteria and search ZAP Where Used Information`; 
   MSG1[6] = `ZAP Reporting & Analytics Portal`; 
   MSG1[7] = `Choose a file and click "Upload" to process`; 
  
   var MESSAGE = MSG1[n];
   (document.getElementById("MSG1")  as HTMLInputElement).hidden = false; 
   (document.getElementById("MSG1")  as HTMLInputElement).value = `${MESSAGE}`; 
  
   if (n == '4') {  
      this.fetch2('%');
      }
   
   if (n == '5') { 
      (document.getElementById("inFLD0") as HTMLSelectElement).selectedIndex = 1;
      (document.getElementById("inZAP")  as HTMLInputElement).value = `27`; 
      (document.getElementById("inFLD1")  as HTMLInputElement).value = ``; 
      (document.getElementById("inFLD2")  as HTMLInputElement).value = ``; 
      (document.getElementById("inFLD3")  as HTMLInputElement).value = ``; 
      }
   else { 
      (document.getElementById("inZAP")  as HTMLInputElement).value = ``; 
   }

   if (n == '6') {  
    this.getZAP();
    (document.getElementById("MSG1")  as HTMLInputElement).hidden = true; 
    }

    if (n == '7') {  
      this.getUploadReport();
     // (document.getElementById("btnUpload1")  as HTMLInputElement).style.display = 'none'; 
      (document.getElementById("btnUpload2")  as HTMLInputElement).style.display = 'none'; 
      }
     // alert("HELLO NINE");
      if (n == '9') {  
      //  alert("ZIRA NINE")
        this.getZiraReport();
     //   (document.getElementById("btnUpload2")  as HTMLInputElement).style.display = 'none'; 
        }
  }


private testLink1 = (parm: any): void => {
    // parm.preventDefault();
     alert("Test Link: " + parm);
}


private csvDownload = (): void => {
      // alert("Download");

         let csv2 = localStorage.getItem("key")

         var hiddenElement = document.createElement('a');  
         hiddenElement.href = 'data:text/csv;charset=utf-8,' + encodeURI(csv2);  
         hiddenElement.target = '_blank';  

         //provide the name for the CSV file to be downloaded  
         hiddenElement.download = 'JSON CSV.csv';  
         hiddenElement.click();  
      
}

  /*
  private handleChange = (): void => {
 
  // this.getDateValue();
   let DATE1 = (document.getElementById("inDate")  as HTMLSelectElement).value;
   // alert('Hello: ' + DATE1);
   if (DATE1 == '') { this.getDate(); DATE1 = (document.getElementById("inDate")  as HTMLSelectElement).value; }

   (document.getElementById("MSG1")  as HTMLInputElement).value = `.`; 

   // Department/ReportType Filter is either/or Choice
   var e = (document.getElementById("ddSYS") as HTMLSelectElement);
   let inDept = e.options[e.selectedIndex].value;

   if (inDept != 'ALL') {  
       var e = (document.getElementById("ddRPT") as HTMLSelectElement);
       e.value = 'ALL';
       }
   else {
        var e = (document.getElementById("ddRPT") as HTMLSelectElement);
        let inRpt = e.options[e.selectedIndex].value;
        if (inRpt  != 'ALL') {
           var e = (document.getElementById("ddSYS") as HTMLSelectElement);
           e.value = 'ALL';
           }
        }

   this.getDropDown3('1');
  }

  

  private handleDate = (): void => {
 
    // this.getDateValue();
    // let DATE1 = (document.getElementById("inDate")  as HTMLSelectElement).value;
     // alert('Hello: ' + DATE1);
     this.getDateValue();
//     if (DATE1 == '') { this.getDate(); DATE1 = (document.getElementById("inDate")  as HTMLSelectElement).value; } 

    }

    
  private handleSelection = (): void => {
      
    this.getDateValue();
    let DATE1 = (document.getElementById("inDate")  as HTMLSelectElement).value;
   //  alert('Hello: ' + DATE1);
    if (DATE1 == '') { this.getDate(); DATE1 = (document.getElementById("inDate")  as HTMLSelectElement).value; }
 
    (document.getElementById("MSG1")  as HTMLInputElement).value = `Report Selected`; 
 
    
    // Department/ReportType Filter is either/or Choice
    var e = (document.getElementById("ddLIST") as HTMLSelectElement);
    let inLIST = e.options[e.selectedIndex].value;
    const myArray = inLIST.split('~');
   // let in1 = myArray[0];
   // let in2 = myArray[1];
    let in3 = myArray[2];
   // alert("RPT: \n" + in1 + '\n' + in2 + '\n' + in3);

    if (in3.indexOf('${Buyer}') !== -1) {      
      (document.getElementById("tdB1")  as HTMLInputElement).style.visibility = 'visible';
      (document.getElementById("tdB2")  as HTMLInputElement).style.visibility = 'visible';
    } else {
      (document.getElementById("tdB1")  as HTMLInputElement).style.visibility = 'hidden';
      (document.getElementById("tdB2")  as HTMLInputElement).style.visibility = 'hidden';
    }
    if (in3.indexOf('${Warehouse}') !== -1) {
      (document.getElementById("tdW1")  as HTMLInputElement).style.visibility = 'visible';
      (document.getElementById("tdW2")  as HTMLInputElement).style.visibility = 'visible';
    } else {
      (document.getElementById("tdW1")  as HTMLInputElement).style.visibility = 'hidden';
      (document.getElementById("tdW2")  as HTMLInputElement).style.visibility = 'hidden';
    }
 /*
    if (inDept != 'ALL') {  
        var e = (document.getElementById("ddRPT") as HTMLSelectElement);
        e.value = 'ALL';
        }
    else {
         var e = (document.getElementById("ddRPT") as HTMLSelectElement);
         let inRpt = e.options[e.selectedIndex].value;
         if (inRpt  != 'ALL') {
            var e = (document.getElementById("ddSYS") as HTMLSelectElement);
            e.value = 'ALL';
            }
         }
         
     
   }
  */

   /*
 private getCURL = (): void => {
  //const fetch = require('node-fetch');
  //var response = 
  // var url = "http://lathropfs01/pdf/20230410/MR011PHF_.pdf";
  //var url = "https://graph.microsoft.com/v1.0/users/9809bee6-2d64-4286-823c-d73203dd95ae";
  //var url = "https://graph.microsoft.com/v1.0/users/c020cfe3-b1b7-4a5b-aa0b-2ee7e48ea939";
  //var url = "/users/{id | userPrincipalName}";
  var url = "https://graph.microsoft.com/v1.0/sites/ssica.sharepoint.com:/IT-DevTest;"
  //https://ssica.sharepoint.com/sites/IT-DevTest

  // alert('1')
   let xhr = new XMLHttpRequest();
// alert('2')
   xhr.open("GET", url);
   alert("bob")
   xhr.onreadystatechange = function () {
    alert("fred")
      if (xhr.readyState === 4) { 
        alert('FOUND: ' + xhr.status + ' : ' + xhr.responseText + ' : ' + xhr.response)
         console.log(xhr.status);
         console.log(xhr.responseText);
      }};

   xhr.send();


}
*/

private getUserProfile = (x: any): void => {
  //alert("HELLO")
  if (x != 1) {
     var UID = (document.getElementById("UID1")  as HTMLInputElement).value;
  }
  var GET = `GetMyProperties`;
  
  if (UID != '')
  {
    //encodeURIComponent()
     GET = `GetPropertiesFor(accountName=@v)?@v='i:0%23.f|membership|${UID}'`;
 //    GET = `GetPropertiesFor(accountName=@v)?@v='i:0%23.f|membership|bwmmis1@ssica.com'`;
  }

//  alert("WHOM: " +GET);

//this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/GetMyProperties`,

this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/${GET}`,


//   this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/GetMyProperties?$select=Email`,
//   this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/GetMyProperties?$select=DisplayName`,
//   this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/GetMyProperties?$select=Department`,
// For Office 365/SharePoint Online:
// http://siteurl/_api/SP.UserProfiles.PeopleManager/GetPropertiesFor(accountName=@v)?@v=’i:0%23.f|membership|vardhaman@siteurl.onmicrosoft.com’

 SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
   // alert("Return")
  return response.json();

  })
  .then((data: any) => {
   //  alert("Your Department is: " + data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value);
  // alert(data.DisplayName);
  // alert(data.Email);

  
  var results = data.UserProfileProperties;

  var html = `<table>`;
  var i=0;
  for (i = 0; i < results.length; i++) { 
      html += `<tr><td> ${results[i].Key}</td><td> ${results[i].Value} </td></tr>`;

   };
     // alert("DEPT:" + data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value);
  // var myDept = data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value;
  // alert("DEPT:" + myDept)
  // if (UID == '') { document.getElementById("DeptInfo").innerHTML = myDept; }

  html += `</table>`;
  document.getElementById("allItems").innerHTML = html;
  //alert('HTML:' + html);
   
   return data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value;
  //alert(data.DisplayName);
  //alert(data.Email);

  //alert("PHON:" + data.UserProfileProperties.find((p: any) => p.Key === 'WorkPhone').Value);
  //alert("ACCT:" + data.UserProfileProperties.find((p: any) => p.Key === 'AccountName').Value);
  //alert("SPSD:" + data.UserProfileProperties.find((p: any) => p.Key === 'SPS-Department').Value);
  })
  .catch((err: any) => {
    //alert("ERR")
    var html = `<p>${UID} Not Found:`;
    document.getElementById("allItems").innerHTML = html;

  console.log(err);
  });
  //</User, Department>
}



private listAllUsers = (x: any): void => {
  //alert("HELLO")
  if (x != 1) {
     var UID = (document.getElementById("UID1")  as HTMLInputElement).value;
  }
  var GET = `GetMyProperties`;
  
  if (UID != '')
  {
    //encodeURIComponent()
     GET = `GetPropertiesFor(accountName=@v)?@v='i:0%23.f|membership|${UID}.UserPrincipalName'`;
 //    GET = `GetPropertiesFor(accountName=@v)?@v='i:0%23.f|membership|bwmmis1@ssica.com'`;
                                                //('i:0#.f|membership|'+$User.UserPrincipalName))
  }

//  alert("WHOM: " +GET);

//this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_vti_bin/ListData.svc/UserInformationList`,
//this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `//_api/Web/SiteUsers`,
this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/${GET}`,

//   this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/GetMyProperties?$select=Email`,
//   this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/GetMyProperties?$select=DisplayName`,
//   this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/GetMyProperties?$select=Department`,
// For Office 365/SharePoint Online:
// http://siteurl/_api/SP.UserProfiles.PeopleManager/GetPropertiesFor(accountName=@v)?@v=’i:0%23.f|membership|vardhaman@siteurl.onmicrosoft.com’

 SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
   // alert("Return")
   alert(`Status code: ${response.status}` +  `${response.statusText}`);
   response.json().then((responseJSON) => {
    var len1 = responseJSON.length;
    alert('JSON:' + len1 + " " + JSON.stringify(responseJSON));
   /* len1 = JSON.stringify(responseJSON.value[0]);
    alert("TITLE:" + len1)
    len1 = JSON.stringify(responseJSON.value[1]);
    alert("TITLE:" + len1)
    len1 = JSON.stringify(responseJSON.value[2]);
    alert("TITLE:" + len1)
    len1 = JSON.stringify(responseJSON.value[3]);
    alert("TITLE:" + len1)
    */
    len1 = JSON.stringify(responseJSON.value[4]);
    alert("TITLE:" + len1)
    len1 = JSON.stringify(responseJSON.value[5]);
    alert("TITLE:" + len1)
    len1 = JSON.stringify(responseJSON.value[6]);
    alert("TITLE:" + len1)
    
   })
  
  return response.json();

  })
  .then((data: any) => {
   //  alert("Your Department is: " + data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value);
  // alert(data.DisplayName);
  // alert(data.Email);

  
  var results = data.UserProfileProperties;

  var html = `<table>`;
  var i=0;
  for (i = 0; i < results.length; i++) { 
      html += `<tr><td> ${results[i].Key}</td><td> ${results[i].Value} </td></tr>`;

   };
     // alert("DEPT:" + data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value);
  // var myDept = data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value;
  // alert("DEPT:" + myDept)
  // if (UID == '') { document.getElementById("DeptInfo").innerHTML = myDept; }

  html += `</table>`;
  document.getElementById("allItems").innerHTML = html;
  //alert('HTML:' + html);
   
   return data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value;
  //alert(data.DisplayName);
  //alert(data.Email);

  //alert("PHON:" + data.UserProfileProperties.find((p: any) => p.Key === 'WorkPhone').Value);
  //alert("ACCT:" + data.UserProfileProperties.find((p: any) => p.Key === 'AccountName').Value);
  //alert("SPSD:" + data.UserProfileProperties.find((p: any) => p.Key === 'SPS-Department').Value);
  })
  .catch((err: any) => {
    //alert("ERR")
    var html = `<p>${UID} Not Found:`;
    document.getElementById("allItems").innerHTML = html;

  console.log(err);
  });
  //</User, Department>
}

private getUserStore = () => {
  //alert("Store")
  var GET = `GetMyProperties`;

this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/SP.UserProfiles.PeopleManager/${GET}`,

SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
   // alert("Return")
  return response.json();

  })
  .then((data: any) => {
    var myDept = data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value;
   //  alert("DEPT:" + data.UserProfileProperties.find((p: any) => p.Key === 'Department').Value);
    (document.getElementById("userDEPT")  as HTMLInputElement).value = myDept;
    var myStore = '101222';
    (document.getElementById("userSTORE")  as HTMLInputElement).value = myStore;
    return myDept;
  })
  .catch((err: any) => {
    alert("ERR")
    //document.getElementById("allItems").innerHTML = html;

  console.log(err);
  });
  //</User, Department>
}


private getApi = (): void => {

  (document.getElementById("btn")  as HTMLInputElement).setAttribute("disabled", "disabled");
  (document.getElementById("btnZAP")  as HTMLInputElement).setAttribute("disabled", "disabled");

  var inAPI = (document.getElementById("inAPI")  as HTMLInputElement).value;
  var inFYPD = (document.getElementById("inFYPD")  as HTMLInputElement).value;
  var inFLD0 = (document.getElementById("inFLD0")  as HTMLInputElement).value;
  var inFLD1 = (document.getElementById("inFLD1")  as HTMLInputElement).value;
  var inFLD2 = (document.getElementById("inFLD2")  as HTMLInputElement).value;
  var inFLD3 = (document.getElementById("inFLD3")  as HTMLInputElement).value;
  var inCUST = (document.getElementById("inCUST")  as HTMLInputElement).value;
  var inDT = (document.getElementById("inDT")  as HTMLInputElement).value;
  var inParms = '';
  if (inAPI == '1') { 
    inParms  = '&in0='+inCUST+'&in1='+inDT;
  }
  if (inAPI == '2') { 
    inParms  = '&in0='+inFYPD;
  }
  if (inAPI == '3') { 
    inParms  = '&in0='+inCUST;
  }

  var inZAP = (document.getElementById("inZAP")  as HTMLInputElement).value;
  if (inZAP == '27') {
    inAPI  = '27';
    inFLD1 = inFLD1.trim();
    inFLD1 = inFLD1.replace(/\*/g, "%"); // allow "*" as wild-card
    inFLD2 = inFLD2.trim();
    inFLD2 = inFLD2.replace(/\*/g, "%"); // allow "*" as wild-card
    inFLD3 = inFLD3.trim();
    inFLD3 = inFLD3.replace(/\*/g, "%"); // allow "*" as wild-card
    let CHK0 = (document.getElementById('inZLIST')  as HTMLInputElement).checked;
    if (CHK0 == true) { inAPI = '28'; }
    if (inFLD1 == '' && inFLD2 == '' && inFLD3 == '' && CHK0 == false) {
      (document.getElementById("MSG1")  as HTMLInputElement).value = `Please enter a Search Key.`; 
      (document.getElementById("btnZAP")  as HTMLInputElement).removeAttribute("disabled");
      return;
    }
    inFLD1 = '%'+inFLD1+'%';
    inFLD2 = '%'+inFLD2+'%';
    inFLD3 = inFLD3+'%';
    inParms  = '&in0='+inFLD0+'&in1='+inFLD1+'&in2='+inFLD2+'&in3='+inFLD3;
  }

  //alert("BOB:" + inAPI + ' ' + inParms);

 this.props.context.spHttpClient.get(`https://ssi-node-api-001.azurewebsites.net/app001?&rpt=${inAPI}${inParms}`,
 SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    
    (document.getElementById("btn")  as HTMLInputElement).removeAttribute("disabled");
    (document.getElementById("btnZAP")  as HTMLInputElement).removeAttribute("disabled");

    if (response.ok) {
      response.json().then((responseJSON) => {
        var ctr1 = 0;
        var csv1 = '';
        let html = `<table><tr><th colspan=5>MySQL API Call</th></tr>`;
   
      if (inAPI == '1') { 
        html += "<tr>";
        html += "<td>HHICUSN";
        html += "<td>HHIORNR";
        html += "<td>HHILNOI";
        html += "<td>dateof_lastorder";
        html += "<td>HHIITMN";
        html += "<td>HHIWHSN";
        html += "<td>HHIQYSA";        
      }
      if (inAPI == '2') { 
        html += "<tr>";
        html += "<td>Fiscal Year";
        html += "<td>Period";
        html += "<td>Beg Date";
        html += "<td>End Date";
        var hdg1 = "Fiscal Year"
        csv1 += hdg1+",";  
        var hdg1 = "Period"
        csv1 += hdg1+",";  
        var hdg1 = "Beg Date"
        csv1 += hdg1+",";  
        var hdg1 = "End Date"
        csv1 += hdg1+",";  
        csv1 += "\n";  
      }
      if (inAPI == '4') { 
        html += "<tr><td>Process </td>";
        html += "<td>Description</td>";
        html += "<td>Ship Date </td>";
        html += "<td>Date </td>";
        html += "<td>RECID </td>";
        html += "<td>PDT </td>"; 
      }
      if (inAPI == '27' || inAPI == '28') { 
        html += "<tr>";
        html += "<td>REPORT/MODULE";
        html += "<td>MEASURE";
        html += "<td>PATH";      
      }

        if (responseJSON.length == 0) { 
         // alert("EMPTY");
          document.getElementById("allItems").innerHTML = "No Data Found.";
          return;
        }

        var csv2 = parse(responseJSON);

        if (inAPI == '4' || inAPI == '3') { 
           var call1 = responseJSON[0].length;
         // alert("CALL:" + call1);
           responseJSON.length = call1;
           var csv2 = parse(responseJSON[0]);
        //   var tempx1 = responseJSON[0];
        //   var csv2 = parse(tempx1);
           csv2 = csv2.replace(/#/g, "~");
           }
        var i=0;
        for (i = 0; i < responseJSON.length; i++) { 

          if (inAPI == '1') { 
            html += "<tr>";
            html += "<td>"+responseJSON[i].HHICUSN;
            html += "<td>"+responseJSON[i].HHIORNR;
            html += "<td>"+responseJSON[i].HHILNOI;
            html += "<td>"+responseJSON[i].dateof_lastorder;
            html += "<td>"+responseJSON[i].HHIITMN;
            html += "<td>"+responseJSON[i].HHIWHSN;
            html += "<td>"+responseJSON[i].HHIQYSA;        
          }
          if (inAPI == '2') { 
            html += "<tr>";
          //    html += `<td><button onClick={[testLink1()]}>alert</button>`;
          //  html += `<td> <a href="#" onClick={()=>onClick={this.testLink1('hello')}}>Click here</a>`;
       
            html += "<td>"+responseJSON[i].fy;
            html += "<td>"+responseJSON[i].pd;
            html += "<td>"+responseJSON[i].beg1;
            html += "<td>"+responseJSON[i].end1;

            csv1 += responseJSON[i].fy + (',');  
            csv1 += responseJSON[i].pd + (',');  
            csv1 += responseJSON[i].beg1 +(',');  
            csv1 += responseJSON[i].end1 +(',');  
            csv1 += "\n";  
          }
          if (inAPI == '3') { 
            html += "<tr><td>Banner </td><td>"+responseJSON[0][0].banner;
            html += "<tr><td>Customer </td><td>"+responseJSON[0][0].ffdcusn;
            html += "<tr><td>Code </td><td>"+responseJSON[0][0].ffdshcd;
            html += "<tr><td>Name </td><td>"+responseJSON[0][0].ffdcnmb;
            html += "<tr><td>ADDR1 </td><td>"+responseJSON[0][0].ffdcc1b;
            html += "<tr><td>ADDR2 </td><td>"+responseJSON[0][0].ffdcc2b;
            html += "<tr><td>CITY </td><td>"+responseJSON[0][0].ffdctyb;
            html += "<tr><td>ST </td><td>"+responseJSON[0][0].ffdsteb;
            html += "<tr><td>ZIP </td><td>"+responseJSON[0][0].ffdzpcb;
            html += "<tr><td>Phone </td><td>"+responseJSON[0][0].ffdphnb;        
          }
          if (inAPI == '4') { 
            html += "<tr><td>"+responseJSON[0][i].process;
            html += "<td>"+responseJSON[0][i].description;
            html += "<td>"+responseJSON[0][i].ship_date;
            html += "<td>"+responseJSON[0][i].create_datetime;
            html += "<td>"+responseJSON[0][i].recid;
            html += "<td>"+responseJSON[0][i].pdt;    
          }
          if (inAPI == '27' || inAPI == '28') { 
            html += "<tr><td>"+responseJSON[i].rpt1; 
            html += "<td>"+responseJSON[i].desc1;
            html += "<td>"+responseJSON[i].key2;
            html += "<td>"+responseJSON[i].key1;
          }
          

             ctr1++;
          };

        html += `<tr><td colSpan=5>Number of Records: &nbsp; ${ctr1} </td><tr>`;
        html += `</table>`;
        document.getElementById("allItems").innerHTML = html;
      //  alert('HTML:' + html);

      
      let CHK0 = (document.getElementById('inCSV')  as HTMLInputElement).checked;
      if (inAPI == '2' && CHK0 == true) { 
        // let csvContent = "data:text/csv;charset=utf-8,"  + csv1;
        // var encodedUri = encodeURI(csvContent);
        // window.open(encodedUri);
         var hiddenElement = document.createElement('a');  
         hiddenElement.href = 'data:text/csv;charset=utf-8,' + encodeURI(csv1);  
         hiddenElement.target = '_blank';  
           
                  //provide the name for the CSV file to be downloaded  
         hiddenElement.download = 'My Download File.csv';  
         hiddenElement.click();  
/*
         var hiddenElement = document.createElement('a');  
         hiddenElement.href = 'data:text/csv;charset=utf-8,' + encodeURI(csv2);  
         hiddenElement.target = '_blank';  
           
         //provide the name for the CSV file to be downloaded  
         hiddenElement.download = 'JSON CSV.csv';  
         hiddenElement.click();  
         */
      }
    
       localStorage.setItem("key", csv2);

        console.log(responseJSON);
      });
    } else {
      alert(`Status code: ${response.status} ${response.statusText}`);
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}

private fetch1  = (): void => {
 // alert("FETCH")
  var inAPI = (document.getElementById("inAPI")  as HTMLInputElement).value;
  var inFY = (document.getElementById("inFYPD")  as HTMLInputElement).value;
  var inDT = (document.getElementById("inDT")  as HTMLInputElement).value;

 // body: JSON.stringify(`{ rpt: '2', in0: '2023' }`)
  //  body: `{ rpt: '2', in0: '${inFY}' }`

fetch('https://ssi-node-api-001.azurewebsites.net/app002',{
  method: 'POST',
  body: JSON.stringify({ rpt: inAPI, in0: inFY, in1: inDT }),
  headers: {"Content-Type": "application/json"}
})
.then(function(response){
  if (response.ok) {
 // alert("Response")
  response.json().then((responseJSON) => {
    var ctr1 = 0;
    let html = `<table><tr><th colspan=5>MySQL API Call</th></tr>`;
      
    if (inAPI == '1') { 
      html += "<tr>";
      html += "<td>HHICUSN";
      html += "<td>HHIORNR";
      html += "<td>HHILNOI";
      html += "<td>dateof_lastorder";
      html += "<td>HHIITMN";
      html += "<td>HHIWHSN";
      html += "<td>HHIQYSA";        
    }
    if (inAPI == '2') { 
      html += "<tr>";
      html += "<td>Fiscal Year";
      html += "<td>Period";
      html += "<td>Beg Date";
      html += "<td>End Date";
    }
    if (responseJSON.length == 0) { 
      //  alert("EMPTY");
        document.getElementById("allItems").innerHTML = "No Data Found.";
        return;
      } 
  //  var data=responseJSON;
  //  var data1 = (data[2].pd);
  //  console.log('DATA-REF:' + data1);
  //  alert("HI:" + data)

 
       if (inAPI == '4' || inAPI == '3') { 
         var call1 = responseJSON[0].length;
        // alert("CALL:" + call1);
         responseJSON.length = call1;
          }

       var i=0;
       for (i = 0; i < responseJSON.length; i++) { 

         if (inAPI == '1') { 
           html += "<tr>";
           html += "<td>"+responseJSON[i].HHICUSN;
           html += "<td>"+responseJSON[i].HHIORNR;
           html += "<td>"+responseJSON[i].HHILNOI;
           html += "<td>"+responseJSON[i].dateof_lastorder;
           html += "<td>"+responseJSON[i].HHIITMN;
           html += "<td>"+responseJSON[i].HHIWHSN;
           html += "<td>"+responseJSON[i].HHIQYSA;        
         }
         if (inAPI == '2') { 
           html += "<tr>";
           html += "<td>"+responseJSON[i].fy;
           html += "<td>"+responseJSON[i].pd;
           html += "<td>"+responseJSON[i].beg1;
           html += "<td>"+responseJSON[i].end1;
         }
         if (inAPI == '3') { 
           html += "<tr><td>Banner </td><td>"+responseJSON[0][0].banner;
           html += "<tr><td>Customer </td><td>"+responseJSON[0][0].ffdcusn;
           html += "<tr><td>Code </td><td>"+responseJSON[0][0].ffdshcd;
           html += "<tr><td>Name </td><td>"+responseJSON[0][0].ffdcnmb;
           html += "<tr><td>ADDR1 </td><td>"+responseJSON[0][0].ffdcc1b;
           html += "<tr><td>ADDR2 </td><td>"+responseJSON[0][0].ffdcc2b;
           html += "<tr><td>CITY </td><td>"+responseJSON[0][0].ffdctyb;
           html += "<tr><td>ST </td><td>"+responseJSON[0][0].ffdsteb;
           html += "<tr><td>ZIP </td><td>"+responseJSON[0][0].ffdzpcb;
           html += "<tr><td>Phone </td><td>"+responseJSON[0][0].ffdphnb;        
         }
         if (inAPI == '4') { 
           html += "<tr><td>"+responseJSON[0][i].process;
           html += "<td>"+responseJSON[0][i].description;
           html += "<td>"+responseJSON[0][i].ship_date;
           html += "<td>"+responseJSON[0][i].create_datetime;
           html += "<td>"+responseJSON[0][i].recid;
           html += "<td>"+responseJSON[0][i].pdt;    
         }
         ctr1++;
      };

    html += `<tr><td colSpan=2>Number of Records:</td><td> ${ctr1} </td><tr>`;
    html += `</table>`;
    document.getElementById("allItems").innerHTML = html;
  //  alert('HTML:' + html);
    console.log(responseJSON);
  });
}
  else {
    alert(`Status code: ${response.status}` +  `${response.statusText}`);
  }
  return;
  //return response.json()

}).then(function(body){
  console.log(body);
 // alert("BODY:" + body);
});
}

private fetch2  = (in1: any): void => {
 //  alert("FETCH2")
 //  var inAPI = (document.getElementById("inAPI")  as HTMLInputElement).value;
 //  var inFY = (document.getElementById("inFY")  as HTMLInputElement).value;
 //  var inDT = (document.getElementById("inDT")  as HTMLInputElement).value;
 
  // body: JSON.stringify(`{ rpt: '2', in0: '2023' }`)
   //  body: `{ rpt: '2', in0: '${inFY}' }`
 
 fetch('https://ssi-node-api-001.azurewebsites.net/app002',{
   method: 'POST',
   body: JSON.stringify({ rpt: 8, in0: `seq,title,sql_stmt`, in1: `zzz_api_queries`,  in2: `seq like '${in1}' order by 1, 2 desc `}),
   headers: {"Content-Type": "application/json"}
 })
 .then(function(response){
 
  if (response.ok) {
   //alert("Response")
   response.json().then((responseJSON) => {
       var ctr1 = 0;
       let html = `<table><tr><th></th><th colspan=5>List of SQL Queries</th></tr>`;
       
       html += "<tr><th></th>";
       html += "<td>ID";
       html += "<td>TITLE";
       html += "<td>SQL STATEMENT";
 
       if (responseJSON.length == 0) { 
          alert("EMPTY");
          document.getElementById("allItems").innerHTML = "No Data Found.";
          return;
       }
 
       var i=0;
       for (i = 0; i < responseJSON.length; i++) { 
         html += `<tr><td><input type="checkbox" id="cbX${ctr1}"></td>`;
         html += `<td><input type="text" size="1"  disabled className={styles.FLD1} id="ID${ctr1}" value="${responseJSON[i].seq}">`;
         html += `<td><input type="text" size="20" disabled className={styles.FLD1} id="TITLE${responseJSON[i].seq}" value="${responseJSON[i].title}">`;
         html += `<td><input type="text" size="99" disabled className={styles.FLD1} id="SQL${responseJSON[i].seq}" value="${responseJSON[i].sql_stmt}">`; 
         ctr1++;
       };
 
     html += `<tr><td colSpan=4>Number of Records:  ${ctr1} </td></tr>`;
     html += `</table><p><input type="hidden" id=CTR1 value='${ctr1}'>`;
    // var xhtml = `<tr><td colSpan=4>Number of Records:</td><td> ${ctr1} </td></tr>`;
    // alert('CTR1:' + ctr1 + ' ' + xhtml);

     document.getElementById("allItems").innerHTML = html;
    // alert('HTML:' + html);

    (document.getElementById("MSG1")  as HTMLInputElement).value = `Select a Query from the list.`; 

     console.log(responseJSON);
   });
  }
   else {
    alert(`Status code: ${response.status}` +  `${response.statusText}`);
  }
   return;
   //return response.json()
 
 }).then(function(body){
   console.log(body);
  // alert("BODY:" + body);
 });
 }

 private fetch3  = (in1: any): void => {
  //  alert("FETCH3")
    var inID = (document.getElementById("inID")  as HTMLInputElement).value;
    var inTITLE = (document.getElementById("inTITLE")  as HTMLInputElement).value;
    var inSQL = (document.getElementById("inSQL")  as HTMLInputElement).value;
  
    inTITLE = inTITLE.replace(/'/g, "''");
    inSQL = inSQL.replace(/'/g, "''");
   // alert("IN:" + inID + "\n" + inTITLE + "\n" + inSQL);
   // body: JSON.stringify(`{ rpt: '2', in0: '2023' }`)

   // var CMD = JSON.stringify({ rpt: 10, in0: `zzz_api_queries`, in1: `(seq,title,sql_stmt)`, in2: `(${inID},'${inTITLE}','${inSQL}')`});
   // alert("CMD:" + CMD);


    
  fetch('https://ssi-node-api-001.azurewebsites.net/app003',{
      method: 'POST',
      body: JSON.stringify({ rpt: 10, in0: `zzz_api_queries`, in1: `(seq,title,sql_stmt)`, in2: `(${inID},'${inTITLE}','${inSQL}')`}),
      headers: {"Content-Type": "application/json"}
    })
/*
    fetch('https://ssi-node-api-001.azurewebsites.net/app003',{
    method: 'POST',
    body: JSON.stringify({ rpt: 10, in0: `zzz_api_queries`, in1: `(seq,title,sql_stmt)`, in2: `(${inID}','${inTITLE}','${inSQL}')`}),
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  */
  .then(function(response){
    if (response.ok) {

    //alert("Response")
    response.json().then((responseJSON) => {
     // alert(`Status code: ${response.status}` + ' ' + `${response.statusText}` );
      if (response.ok) { 
        document.getElementById("allItems").innerHTML = "Record was Updated.";
        return;
      }
      console.log(responseJSON);
    });
  }
  else {
    alert(`Status code: ${response.status}` +  `${response.statusText}`);
  }
    return;
    //return response.json()
  
  }).then(function(body){
    console.log(body);
   // alert("BODY:" + body);
  });
  }

  private fetch4  = (in1: any): void => {
    //  alert("FETCH4")
    var inTITLE = (document.getElementById("inTITLE")  as HTMLInputElement).value;
    var inSQL = (document.getElementById("inSQL")  as HTMLInputElement).value;
    inTITLE = inTITLE.replace(/'/g, "''");
    inSQL = inSQL.replace(/'/g, "''");
   // alert("IN:"  + inTITLE + "\n" + inSQL);

    fetch('https://ssi-node-api-001.azurewebsites.net/app003',{
      method: 'POST',
      body: JSON.stringify({ rpt: 9, in0: `zzz_api_queries`, in1: `(title,sql_stmt)`, in2: `('${inTITLE}','${inSQL}')`}),
      headers: {"Content-Type": "application/json"}
    })
    .then(function(response){
      if (response.ok) {

        //alert("Response")
        response.json().then((responseJSON) => {
         // alert(`Status code: ${response.status}` + ' ' + `${response.statusText}` );
          if (response.ok) { 
            document.getElementById("allItems").innerHTML = "Record was Inserted.";
            return;
          }
          console.log(responseJSON);
        });
      }
      else {
        alert(`Status code: ${response.status}` +  `${response.statusText}`);
      }
        return;
        //return response.json()
    
    }).then(function(body){
      console.log(body);
     // alert("BODY:" + body);
    });
    }

    private fetch5  = (in1: any): void => {
      //  alert("FETCH5")
      var inCHK = (document.getElementById("MSG1")  as HTMLInputElement).value;
      if (inCHK != 'Click on "Delete" again to confirm') {
        (document.getElementById("MSG1")  as HTMLInputElement).value = 'Click on "Delete" again to confirm';
        return;
      }

      var inID = (document.getElementById("inID")  as HTMLInputElement).value;
     // alert("IN:"  + inID);
  
      fetch('https://ssi-node-api-001.azurewebsites.net/app003',{
        method: 'POST',
        body: JSON.stringify({ rpt: 11, in0: `zzz_api_queries`, in1: `seq = ${inID}`}),
        headers: {"Content-Type": "application/json"}
      })
      .then(function(response){
        if (response.ok) {
  
          //alert("Response")
          response.json().then((responseJSON) => {
           // alert(`Status code: ${response.status}` + ' ' + `${response.statusText}` );
            if (response.ok) { 
              document.getElementById("allItems").innerHTML = "Record was Deleted.";
              return;
            }
            console.log(responseJSON);
          });
        }
        else {
          alert(`Status code: ${response.status}` +  `${response.statusText}`);
        }
          return;
          //return response.json()
      
      }).then(function(body){
        console.log(body);
       // alert("BODY:" + body);
      });
      }


// Process Changes
  private processChanges = (): void => {
     let ID001 = (document.getElementById("CTR1")  as HTMLInputElement).value;
     let CTRx = 0;
     CTRx = parseInt(ID001);

     let i = 0;
   
     do { 
      let ID   = (document.getElementById('ID'+i)  as HTMLInputElement).value;
      let CHK0 = (document.getElementById('cbX'+i)  as HTMLInputElement).checked;
     // alert('CTRx: ' + i + '\n' + CHK0 + '\n' + ID);

       let inTITLE = (document.getElementById('TITLE'+ID)  as HTMLInputElement).value;
       let inSQL = (document.getElementById('SQL'+ID)  as HTMLInputElement).value;
    
       if (CHK0 == true) { 
          (document.getElementById('inID')  as HTMLInputElement).value = ID;
          (document.getElementById('inTITLE')  as HTMLInputElement).value = inTITLE;
          (document.getElementById('inSQL')  as HTMLInputElement).value = inSQL;
          var el = document.getElementById("inSQL");
          el.style.height = "auto";
          el.style.height = (5 + el.scrollHeight) + "px";
          (document.getElementById("MSG1")  as HTMLInputElement).value = `Make changes and click on "Save" to process.`;
         // alert("SELECTED:" + ID);
          return;
          //   this.createItem(i);            
       }

       
       i++;
       } 
       while (i < CTRx && i != 999);

       (document.getElementById("MSG1")  as HTMLInputElement).value = `Please select an item from the list.`;
        
      
};

/*
// Create Item
  private createItem = (i: any): void => {

   let ID   = (document.getElementById('ID'+i)  as HTMLInputElement).value;
   //alert("0")

   let ID1 = (document.getElementById('Title'+ID)  as HTMLInputElement).value;
   //alert("1")
   let ID2 = (document.getElementById('ReportType'+ID)  as HTMLInputElement).value;
   //alert("2")
   let ID3 = (document.getElementById('Department'+ID)  as HTMLInputElement).value;
   //alert("3")
   let ID4 = (document.getElementById('ReportID'+ID)  as HTMLInputElement).value;
   //alert("4")
   let ID5 = (document.getElementById('JobName'+ID)  as HTMLInputElement).value;
   //alert("5")
   let ID6 = (document.getElementById('URL1'+ID)  as HTMLInputElement).value;
   //alert("6")
   let ID7 = (document.getElementById('SplitBy'+ID)  as HTMLInputElement).value;
   //alert("7")
   let ID8 = (document.getElementById('Active'+ID)  as HTMLInputElement).value;

   
  // alert('Create: ' + ID + '\n' + ID1 + '\n' + ID2 + '\n' + ID3 + '\n' + ID4 + '\n' + ID5 + '\n' + ID6  + '\n' + ID7  + '\n' + ID8);

  //return;

    const body: string = JSON.stringify({
      'Title': ID1,
      'ReportType': ID2,
      'Department': ID3,
      'ReportID': ID4,
      'JobName': ID5,
      'URL': ID6,
      'SplitBy': ID7,
      'Active': ID8
    });
    this.props.context.spHttpClient.post(`https://ssica.sharepoint.com/_api/web/lists/getbytitle('Report Master List')/items`,
      SPHttpClient.configurations.v1, {
      headers: {
        'Accept': 'application/json;odata=nometadata',
        'Content-type': 'application/json;odata=nometadata',
        'odata-version': ''
      },
      body: body
    })
      .then((response: SPHttpClientResponse) => {
        if (response.ok) {
          response.json().then((responseJSON) => {
            console.log(responseJSON);
          //  alert(`Item created successfully with ID: ${responseJSON.ID}`);
            (document.getElementById("MSG1")  as HTMLInputElement).value = `Data was Saved`;
          });
        } else {
          response.json().then((responseJSON) => {
            console.log(responseJSON);
            alert(`Create: Something went wrong! Check the error in the browser console.`);
          });
        }
      }).catch(error => {
        console.log(error);
      });
   
 }
 */

  
/*
// Get all items
  private getAllItems = (): void => {

    this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report Master List')/items?&$orderBy=ID&$top=999`,
   
    SPHttpClient.configurations.v1,
    {
      headers: {
        'Accept': 'application/json;odata=nometadata',
        'odata-version': ''
      }
    })
    .then((response: SPHttpClientResponse) => {
      if (response.ok) {
        response.json().then((responseJSON) => {
          let html = ` <table className={styles.tb1}><tr><th colspan=2>List of Available Reports</th></tr>`;
          let ctr1 = 0;
          responseJSON.value.map((item: any, index: any) => {
                     html += `<tr><td><input type="checkbox" id="cbX${item.ID}"></td><td>${item.Title}`;
            html += `<tr><td><input type="text" size="3" id="ID${ctr1}" value="${item.ID}">`;
            let URL1 = `${item.URL}`;
            URL1 = URL1.replace('lathop','lathrop');
            html += `<td><input type="text" id="REPORT${item.URL}" value="${URL1}">`;
            ctr1++;
            let id1 = `${item.ID}`;
            this.updateItem(id1, URL1);
          });
          html += `</table><p><input type="hidden" id=CTR1 value='${ctr1}'>`;
          document.getElementById("allItems").innerHTML = html;
          alert('HTML:' + html);
          console.log(responseJSON);
     
          let MSGOK = (document.getElementById("MSG1")  as HTMLInputElement).value;
          if (MSGOK != 'Data was Saved') { 
            (document.getElementById("MSG1")  as HTMLInputElement).value = `Select/Unselect Reports and Click on 'Save' to process.`;
          }
          
        }); // .then(() => this.findSelectedReports());
      } else {
        response.json().then((responseJSON) => {
          console.log(responseJSON);
          alert(`Something went wrong! Check the error in the browser console.`);
        });
      }
    }).catch(error => {
      console.log(error);
    });
  }
  */
 
  /*
// Get List of Departments for UserID
private getDropDown1 = (): void => {
    const id0: string = this.props.context.pageContext.user.loginName;

    this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report User List')/items?$filter=UserID eq '${id0}'&$orderBy=Department,ReportType desc&$top=1000`,
   
    SPHttpClient.configurations.v1,
    {
      headers: {
        'Accept': 'application/json;odata=nometadata',
        'odata-version': ''
      }
    })
    .then((response: SPHttpClientResponse) => {
      if (response.ok) {
   
        response.json().then((responseJSON) => {
          let key0 = '';
      //    let ctr1 = 0;
          let html = `<option value="ALL">ALL</option>`;
          responseJSON.value.map((item: any, index: any) => {
            let key1 = `${item.Department}`;
            if (key1 != key0) {
               html += `<option value="${item.Department}"> ${item.Department}`;
               key0 = key1;
            }        
      //     ctr1++;
           });
          html += `</select>`;
          document.getElementById("ddSYS").innerHTML = html;
         // alert('HTML:' + html);
          console.log(responseJSON);             
        });
      } else {
        response.json().then((responseJSON) => {
          console.log(responseJSON);
          alert(`Something went wrong! Check the error in the browser console.`);
        });
      }
    }).catch(error => {
      console.log(error);
    });
  }

      
// Get List of Report Types for UserID
private getDropDown2 = (): void => {
    const id0: string = this.props.context.pageContext.user.loginName;
    
    this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report User List')/items?$filter=UserID eq '${id0}'&$orderBy=ReportType,Department&$top=1000`,
   
    SPHttpClient.configurations.v1,
    {
      headers: {
        'Accept': 'application/json;odata=nometadata',
        'odata-version': ''
      }
    })
    .then((response: SPHttpClientResponse) => {
      if (response.ok) {
   
        response.json().then((responseJSON) => {
          let key0 = '';
      //    let ctr1 = 0;
          let html = `<option value="ALL">ALL</option>`;
          responseJSON.value.map((item: any, index: any) => {
            let key1 = `${item.ReportType}`;
            if (key1 != key0) {
               html += `<option value="${item.ReportType}"> ${item.ReportType}`;
               key0 = key1;
            }
      //     ctr1++;
           });
          html += `</select>`;
          document.getElementById("ddRPT").innerHTML = html;
         // alert('HTML:' + html);
          console.log(responseJSON);            
        });
      } else {
        response.json().then((responseJSON) => {
          console.log(responseJSON);
          alert(`Something went wrong! Check the error in the browser console.`);
        });
      }
    }).catch(error => {
      console.log(error);
    });
  }

    
// Get List of Active Reports for UserID
private getDropDown3 = (in1: any): void => {
    const id0: string = this.props.context.pageContext.user.loginName;
    
    let inDept = '';
    let inRpt  = '';
    let filter = '';
    if (in1 != '') {
       var e = (document.getElementById("ddSYS") as HTMLSelectElement);
       inDept = e.options[e.selectedIndex].value;
       if (inDept != 'ALL') { filter += " and Department eq '"+inDept+"'"; }

       var e = (document.getElementById("ddRPT") as HTMLSelectElement);
       inRpt = e.options[e.selectedIndex].value;
       if (inRpt  != 'ALL') { filter += " and ReportType eq '"+inRpt+"'"; }
     //  alert("in: " + inDept + ' ' + inRpt)
    }  

    //alert("filter: " + filter);

    this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report User List')/items?$filter=UserID eq '${id0}'${filter}&$orderBy=Department,ReportType desc&$top=1000`,
   
    SPHttpClient.configurations.v1,
    {
      headers: {
        'Accept': 'application/json;odata=nometadata',
        'odata-version': ''
      }
    })
    .then((response: SPHttpClientResponse) => {
      if (response.ok) {
   
        response.json().then((responseJSON) => {
      //    let ctr1 = 0;
      //    let html = `<option value="ALL">ALL</option>`;
          let sp1  = '__________';
          let fld1 = '';
          let fld2 = '';
          let html = `<option value="0">* List of Active Reports *</option>`;
          responseJSON.value.map((item: any, index: any) => {          
            fld1 = `${item.Department}`+sp1;
            fld1 = fld1.substring(0,8);
            fld1 = fld1.replace(/_/g, "&nbsp;");
            fld2 = `${item.ReportType}`+sp1;
            fld2 = fld2.substring(0,8);
            fld2 = fld2.replace(/_/g, "&nbsp;");
            const OPT = `${item.Department}`+'~'+`${item.ReportType}`+'~'+`${item.URL}`;
            html +=`<option value="${OPT}"> ${fld1} ${fld2} ${item.Title}`;
        //     ctr1++;
           });
          html += `</select>`;
          document.getElementById("ddLIST").innerHTML = html;
        //  alert('HTML:' + html);
          console.log(responseJSON);         
        });
      } else {
        response.json().then((responseJSON) => {
          console.log(responseJSON);
          alert(`Something went wrong! Check the error in the browser console.`);
        });
      }
    }).catch(error => {
      console.log(error);
    });
  }

      
// Get List of Buyers
private getDropDown4 = (): void => {
  
  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Buyers')/items?&$orderBy=Title`,
 
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
   
      response.json().then((responseJSON) => {
    //    let ctr1 = 0;
        let html = ``;
        responseJSON.value.map((item: any, index: any) => {          
          html +=`<option value="${item.Title}">${item.Title}`;
      //     ctr1++;
         });
        html += `</select>`;
        document.getElementById("ddBUYER").innerHTML = html;
        (document.getElementById("tdB1")  as HTMLInputElement).style.visibility = 'hidden';
        (document.getElementById("tdB2")  as HTMLInputElement).style.visibility = 'hidden';
      //  alert('HTML:' + html);
        console.log(responseJSON);         
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}

      
// Get List of Report Types for UserID
private getDropDown5 = (): void => {
  
  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Warehouses')/items?&$orderBy=Title`,
 
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
   
      response.json().then((responseJSON) => {
    //    let ctr1 = 0;
        let html = ``;
        responseJSON.value.map((item: any, index: any) => {          
          html +=`<option value="${item.Title}">${item.Title}`;
      //     ctr1++;
         });
        html += `</select>`;
        document.getElementById("ddWHSE").innerHTML = html;
        (document.getElementById("tdW1")  as HTMLInputElement).style.visibility = 'hidden';
        (document.getElementById("tdW2")  as HTMLInputElement).style.visibility = 'hidden';
      //  alert('HTML:' + html);
        console.log(responseJSON);         
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}
*/

// Get Audit Trail Information
private getAuditTrail = (): void => {
  var inRPT = '1';
  var e = (document.getElementById("ddAUDIT") as HTMLSelectElement);
  inRPT = e.options[e.selectedIndex].value;
  if (inRPT == '1') { var field = 'RunDate desc'; }   
  if (inRPT == '2') { var field = 'UserName'; }  
  if (inRPT == '3') { var field = 'Title'; }  
  const PARAMS: string = "&$orderBy="+field;

  //   const PARAMS: string = "&$select="+field+"&$orderBy="+field;
  //   alert("PARAMS:" + PARAMS);
  // const PARAMS: string = "&$filter=RunDate ge '04/11/2023'&$orderBy="+field;
  
 // this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('ZZZ AUDIT TRAIL')/items?${PARAMS}&$orderBy=Department,ReportType&$top=999`,
  this.props.context.spHttpClient.get(`https://ssica.sharepoint.com/_api/web/lists/getbytitle('ZZZ AUDIT TRAIL')/items?${PARAMS}&$orderBy=Department,ReportType&$top=999`,
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
      response.json().then((responseJSON) => {
        var ctr1 = 0;
        var ctr2 = 0;
        var ctr3 = 0;
        var key0 = '';
        var itemX = '';
    //    var USER1 = '';
    //    var TITLE = '';
    //    var RUND = '';
        let html = `<table><tr><th></th><th colspan=3>Audit Trail Reports</th></tr>`;
        html += `<tr><th></th><th>Description</th><th>Number of Reports</th>`;
     
        responseJSON.value.map((item: any, index: any) => {
          if (inRPT == '1') { var key1 = `${item.RunDate}`; key1 = key1.substring(0,10); }
          if (inRPT == '2') { var key1 = `${item.UserName}`+" "+`${item.UserID}`; }
          if (inRPT == '3') { var key1 = `${item.Title}`; }
          
          if (key1 != key0) {
             if (ctr1 != 0) {
              var cbox = `<td><input type="checkbox" id="cbX${item.ID}"></td>`; 
              html += `<tr>${cbox}</td><td>${key0}</td><td style="text-align:right;"> ${ctr1}</td></tr>`;
             }
             key0 = key1;
             ctr1=0;
             ctr2++;
          }
          itemX = `${item.ID}`;
          ctr1++;
          ctr3++;
        });
   
        var cbox = `<td><input type="checkbox" id="cbX${itemX}"></td>`; 
        html += `<tr>${cbox}</td><td>${key0}</td><td  style="text-align:right;"> ${ctr1} </td><tr>`;
        html += `<tr><td></td><td>Count: &nbsp; ${ctr2}</td><td  style="text-align:right;">Total: &nbsp; ${ctr3} </td><tr>`;
      //  html += `<tr><td>${key0}</td><td> ${ctr1} ${RUND}</td><td> ${USER1} ${TITLE}</tr>`;
        html += `</table>`;
        document.getElementById("allItems").innerHTML = html;
      //alert('HTML:' + html);
        console.log(html);
        console.log(responseJSON);
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}

// Get List of ZAP Reports
private getZAP = (): void => {
  var PARAMS = '';
  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('ZAP Reports')/items?${PARAMS}&$orderBy=field_2,field_1,Title&$top=999`,
  SPHttpClient.configurations.v1,
  {
    headers: {
      'Accept': 'application/json;odata=nometadata',
      'odata-version': ''
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
      response.json().then((responseJSON) => {
        var ctr1 = 0;
        var key0 = '';
        var grp0 = '';
        let html = `<div style="border:none;border-width:2px;width:325px;float:left;"><ul style="list-style-type:none;">`;
      //  let html = `<div className={styles.div2}>`;
      // let html = `<table border=1 width=300>`;
    
        responseJSON.value.map((item: any, index: any) => {
          var key1 = `${item.field_1}`;
          var grp1 = `${item.field_2}`;

          if (grp1 != grp0) {
            if (ctr1 != 0) { 
              html += "</ul></div>"; 
              html += `<div style="border:none;border-width:2px;width:385px;float:left"><ul style="list-style-type:none;">`;
              }
          }

          if (key1 != key0) {
              if (ctr1 != 0) { 
                //html += "</table>";
               }
          //    html += `<div style="border:solid;border-width:2px;width:305px;float:left">`;
          //    html += `<table border=1 width=300><tr><td width=300><h3>${item.field_1}</h3></td>`;        
          //    html += ` <div className={styles.div2}><p><h3>${item.field_1}</h3></p>`;
              html += ` <li style="margin-bottom:1px;"><h3>${item.field_1}</h3></li>`;        
          //    html += ` <div style="border:solid;border-width:2px;width:305px;float:left"><p><h3>${item.field_1}</h3></p>`;        
             }

          var link1 = `<a href="${item.field_3}" target="_blank" style="text-decoration:none"><font color="blue">${item.Title}</font></a>`;
          var desc1 = `${item.field_4}`;
          var descx = '';
          if (desc1 != "null") { descx = "<br><font size=-1>"+`${item.field_4}`+"</font></br>"; }
          html += `<li style="margin-bottom:6px;">${link1} ${descx}</li>`;
     //     html += `<tr><td>${link1} ${descx}</td></tr>`;
          key0 = key1;
          grp0 = grp1;
          ctr1=0;

          ctr1++;
        });
   
      //  html += `<tr></td><td>${key0}</td><td> ${ctr1} </td><tr>`;
      //  html += `<tr><td>${key0}</td><td> ${ctr1} ${RUND}</td><td> ${USER1} ${TITLE}</tr>`;
     //   html += `</table>`;
        html += `</ul></div>`;
        document.getElementById("allItems").innerHTML = html;
      
     // alert('HTML:' + html);
        console.log(responseJSON);
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    console.log(error);
  });
}


// Get File to Upload
private getUploadFile = (): void => {

  let html = "<table>";
  html += `<tr><th>Row </th><th>EE Code </th><th>Last Name </th><th>First Name </th><th>Pay Class </th><th>Department </th><th>Hours Only </th><th>Earn Hours </th><th>Differential </th><th>Diff Earn </th>`;
  let file = (document.getElementById("readfile") as HTMLInputElement).files[0];

  const fileReader = new FileReader();
  fileReader.onload = event => {
    const fileText: any = event.target.result;
    alert("FILE:" + fileText)
    const lines = fileText.split('\n');
   // const len1 = lines.length;
   // alert("line0:" + lines[0] + "LEN:" + len1 )

   var ctr1 = 0;
   let file1 = (document.getElementById("readfile") as HTMLInputElement).value;
   let pos1 = file1.lastIndexOf("\\");
   //alert ("POS: " + pos1)
   let FileName = file1.substring(pos1+1,53);
   let BegDate  = FileName.substring(22,30);
   let EndDate  = FileName.substring(33,41);
   let mm1 = BegDate.substring(0,2);
   let dd1 = BegDate.substring(3,5);
   let yy1 = BegDate.substring(6,8);
   let BegDate2 = "20"+yy1+"-"+mm1+"-"+dd1;
   mm1 = EndDate.substring(0,2);
   dd1 = EndDate.substring(3,5);
   yy1 = EndDate.substring(6,8);
   let EndDate2 = "20"+yy1+"-"+mm1+"-"+dd1;
   // alert ("X: " + file1 +  '\n' + FileName + '\n' + BegDate + '\n' + EndDate)
   // alert ("New: \n" + BegDate2 + '\n' + EndDate2 + "\n")
  
   let pos2 = file1.lastIndexOf(".");
   let FileSuffix = file1.substring(pos2+1,pos2+4);
    if (FileSuffix != "txt" && FileSuffix != "png" && FileSuffix != "jpg") {
      alert("Invalid file type: " + FileSuffix + "\n Only .txt, .png, .jpg files are allowed.");
      return;
    }
   
    var sql1 = '';
    //let comma = '';
    let i = 1;   // skip over header line
    for (i = 1; i < lines.length; i++) { 
    //  alert('I: ' + i + ' ' + lines[i])
    //  html += `<li> ${lines[i]}`;
    // return;
      //if (i > 1) { comma = ','; }
      
      // Create the individual Insert Statements and save to local storage.
      const myArray = lines[i].split('\t');
      if (myArray[0] == '' || myArray[0] == 'EECode') {  // skip header and blank lines at end
         //alert('I: ' + i + ' ' + lines[i])
         }
      else {
        //  sql1 += `${comma}('${FileName}','${BegDate2}','${EndDate2}'`;
          sql1 += `('${FileName}','${BegDate2}','${EndDate2}'`;
      
         let ix = 0; 
         for (ix = 0; ix < 33; ix++) { 
              sql1 +=  `,'${myArray[ix]}'`;
         };
         sql1 += `)\n`;

         html += `<tr><td>${i} <td>${myArray[0]}`;
         html += `<td> ${myArray[1]}`;
         html += `<td> ${myArray[2]}`;
         html += `<td> ${myArray[3]}`;
         html += `<td> ${myArray[4]}`;
         html += `<td> ${myArray[10]}`;
         html += `<td> ${myArray[11]}`;
         html += `<td> ${myArray[12]}`;
         html += `<td> ${myArray[13]}`;
         ctr1++;
        };
     };
    html += `</table>`;
    html += `<p>${ctr1} `;
 
    // Save the SQL statement to local storage
    localStorage.setItem("SQL1", sql1);
    console.log(sql1)
    
    // Save the SQL statement to local storage
      localStorage.setItem("FILE1", fileText);

    document.getElementById("btnUpload1").style.display = 'block';

    document.getElementById("allItems").innerHTML = html;
    (document.getElementById("MSG1")  as HTMLInputElement).value = `Total of ${ctr1} records selected.  Click on "Save to MySQL" to upload to database.`; 

  };
  fileReader.readAsText(file);

}

private getUploadReport  = (): void => {
  
//const request = require('request-promise-native');
//const siteUrl = this.props.context.pageContext.web.absoluteUrl;
//const folderUrl = '/sites/IT-DevTest/SiteAssets';
//`${siteUrl}/_api/web/GetFolderByServerRelativeUrl('${folderUrl}')/Files`,

//this.props.context.spHttpClient.get(`https://ssica.sharepoint.com/_api/web/GetFolderByServerRelativeUrl('${folderUrl}')/Files`,

//this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl+`/Site%20Assets/_api/web/lists/GetByTitle('Site Assets')/items?$expand=File`,

this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl+`/_api/web/lists/GetByTitle('Site Assets')/items`,
SPHttpClient.configurations.v1,
{
  headers: {
    'Accept': 'application/json;odata=nometadata',
    'odata-version': ''
  }
})
.then((response: SPHttpClientResponse) => {
  if (response.ok) {
    response.json().then((responseJSON) => {
//      var ctr1 = 0;

      let html = ``;
     // let len1 = responseJSON.length;
      //alert("HELLO" + len1);
    
      responseJSON.value.map((item: any, index: any) => {
        var key1 = `${item.Title}`;
        var key2 = `${item.Modified}`;
        var key3 = `${item.ModifiedBy}`;
        var key4 = `${item.Name}`;
       // alert("RESP:" + key1)
        html += `<p>hello?` + key1 + " " + key3 + " " + key2 + " " + key4;
  //      ctr1++;
      }); 
 
      document.getElementById("allItems").innerHTML = html;
    
   // alert('HTML:' + html);
      console.log(responseJSON);
    });
  } else {
    response.json().then((responseJSON) => {
      console.log(responseJSON);
      alert(`Something went wrong! Check the error in the browser console.`);
    });
  }
}).catch(error => {
  console.log(error);
});
}

 

private getZiraReport  = (): void => {
  
  alert("HELLO ZIRA")
  
  var URL1 = 'https://api.zira.us/public/data-sources?textSearch=CS&limit=5';
 // var URL1 = 'https://api.zira.us/public/export?meterId=29838&limit=100&endTime=2023-12-22T15:59:59&startTime=2023-11-20T15:00:00';

 this.props.context.spHttpClient.get(`${URL1}`,
 SPHttpClient.configurations.v1,
  {
    headers: {
     // 'Accept': 'application/json;odata=nometadata',
     // 'odata-version': ''
     //,
      'X-Api-Key': '582ef728-28f1-4b4f-9bcb-ba102fc1af08'
    // , 'X-Api-Key': '2XHBIWtrTG9x5inUDVsmo8GCv7nBFRTZ2rq31yk7'
      
    }
  })
  .then((response: SPHttpClientResponse) => {
    if (response.ok) {
      response.json().then((responseJSON) => {
  //      var ctr1 = 0;
  
        let html = ``;
        let len1 = responseJSON.length;
        alert("HELLO" + len1);
      
        responseJSON.value.map((item: any, index: any) => {
          var key1 = `${item.Title}`;
          var key2 = `${item.Modified}`;
          var key3 = `${item.ModifiedBy}`;
          var key4 = `${item.Name}`;
         // alert("RESP:" + key1)
          html += `<p>hello?` + key1 + " " + key3 + " " + key2 + " " + key4;
    //      ctr1++;
        }); 
   
        document.getElementById("allItems").innerHTML = html;
      
     // alert('HTML:' + html);
        console.log(responseJSON);
      });
    } else {
      response.json().then((responseJSON) => {
        console.log(responseJSON);
        alert(`Something went wrong! Check the error in the browser console.`);
      });
    }
  }).catch(error => {
    alert("ERROR ZIRA")
    console.log(error);
  });
  }
  

private saveToMySQL  = (): void => {
  // Get the SQL statement from local storage
  var sql1 = localStorage.getItem("FILE1")
 
  var file = sql1;
  //file = 'THIS IS MY DATA';
  //Upload a file to the SharePoint Library   blake 
  var myStore = (document.getElementById("userSTORE")  as HTMLInputElement).value;
  let today = new Date();
  let date = today.getFullYear()+'-'+(today.getMonth()+1)+'-'+today.getDate();
  let time = today.getHours() + ":" + today.getMinutes() + ":" + today.getSeconds();
  let inDateTime = date+'-'+time;

  var fileName = this.props.context.pageContext.user.loginName+"-"+myStore+"-"+inDateTime+".txt";
  fileName = fileName.replace(/\@/g, "-"); 
  

  alert("FILENAME:" + fileName);
  //return;

 // body: JSON.stringify(`{ rpt: '2', in0: '2023' }`)
  //  body: `{ rpt: '2', in0: '${inFY}' }`
  var inData = `('`+fileName+`','`+file+`')`
alert('DATA:' + inData);
//return;
fetch('https://ssi-node-api-001.azurewebsites.net/app002',{
  method: 'POST',
  body: JSON.stringify({ rpt: 42, in0: inData }),
  headers: {"Content-Type": "application/json"}
})
.then(function(response){
  if (response.ok) {
 // alert("Response")
  response.json().then((responseJSON) => {
    var ctr1 = 0;
    let html = `<table><tr><th colspan=5>MySQL API Call</th></tr>`;
    
    if (responseJSON.length == 0) { 
      //  alert("EMPTY");
        document.getElementById("allItems").innerHTML = "No Data Found.";
        return;
      } 
  //  var data=responseJSON;
  //  var data1 = (data[2].pd);
  //  console.log('DATA-REF:' + data1);
  //  alert("HI:" + data)

      if (responseJSON.length == 0) { 
        // alert("EMPTY");
         document.getElementById("allItems").innerHTML = "No Data Found.";
         return;
       }
 
       var i=0;
       for (i = 0; i < responseJSON.length; i++) { 

         
      //    html += "<td>"+responseJSON[i].end1;
      //    html += "<tr><td>Phone </td><td>"+responseJSON[0][0].ffdphnb;        

         ctr1++;
      };

    html += `<tr><td colSpan=2>Number of Records:</td><td> ${ctr1} </td><tr>`;
    html += `</table>`;
    document.getElementById("allItems").innerHTML = html;
  //  alert('HTML:' + html);
    console.log(responseJSON);
  });
}
  else {
    alert(`Status code: ${response.status}` +  `${response.statusText}`);
  }
  return;
  //return response.json()

}).then(function(body){
  console.log(body);
 // alert("BODY:" + body);
});

}

private getUploadFile2 = (): void => {

  let html = "<table>";
  html += `<tr><th>Row </th><th>EE Code </th><th>Last Name </th><th>First Name </th><th>Pay Class </th><th>Department </th><th>Hours Only </th><th>Earn Hours </th><th>Differential </th><th>Diff Earn </th>`;
  let file = (document.getElementById("readfile2") as HTMLInputElement).files[0];

  const fileReader = new FileReader();
  fileReader.onload = event => {
    const fileText: any = event.target.result;
    alert("FILE:" + fileText)
    //const lines = fileText.split('\n');
   // const len1 = lines.length;
   // alert("line0:" + lines[0] + "LEN:" + len1 )

   var ctr1 = 0;
   let file1 = (document.getElementById("readfile2") as HTMLInputElement).value;
 //  let pos1 = file1.lastIndexOf("\\");
   //alert ("POS: " + pos1)
   
   let pos2 = file1.lastIndexOf(".");
   let FileSuffix = file1.substring(pos2+1,pos2+4);
    if (FileSuffix != "txt" && FileSuffix != "png" && FileSuffix != "jpg") {
      alert("Invalid file type: " + FileSuffix + "\n Only .txt, .png, .jpg files are allowed.");
      return;
    }
   
    var sql1 = fileText;

    html += `</table>`;
    html += `<p>${ctr1} `;
 
    // Save the SQL statement to local storage
    localStorage.setItem("SQL1", sql1);
    console.log(sql1)
    
    // Save the SQL statement to local storage
      localStorage.setItem("FILE1", fileText);

    document.getElementById("btnUpload1").style.display = 'block';

    document.getElementById("allItems").innerHTML = html;
    (document.getElementById("MSG1")  as HTMLInputElement).value = `Total of ${ctr1} records selected.  Click on "Save to MySQL" to upload to database.`; 

  };
  fileReader.readAsText(file);

}

private saveToSPDIR  = (): void => {

//  =================================
  //var url = this.props.context.pageContext.web.serverRelativeUrl;
//  var url = this.props.context.pageContext.web.absoluteUrl + `/Site Assets/`;

  var sql1 = localStorage.getItem("FILE1")
 
  var file = sql1;

  //Upload a file to the SharePoint Library   blake
  var myStore = (document.getElementById("userSTORE")  as HTMLInputElement).value;
  let today = new Date();
  let date = today.getFullYear()+'-'+(today.getMonth()+1)+'-'+today.getDate();
  let time = today.getHours() + ":" + today.getMinutes() + ":" + today.getSeconds();
  let inDateTime = date+'-'+time;

  var fileName = this.props.context.pageContext.user.loginName+"-"+myStore+"-"+inDateTime+".txt";
  fileName = fileName.replace(/\@/g, "-"); 
  

  alert("FILENAME:" + fileName);
  //return;

  const requestOptions: IHttpClientOptions = {

    headers: {

      Accept: "application/json",

    },

    body: file,

  };



  // Perform the file upload

  
this.props.context.spHttpClient
//  props.context.spHttpClient

    .post(

      `https://ssica.sharepoint.com/sites/IT-DevTest/_api/web/GetFolderByServerRelativeUrl('UPLOADS-4-JOSH/')/files/add(url='${fileName}',overwrite=true)`,

      SPHttpClient.configurations.v1,

      requestOptions

    )

    .then((res: SPHttpClientResponse) => {

      return res.json();

    })

    .then((web): void => {

      console.log(web);

    });


    return;
/*
  pnp.sp.web.getFolderByServerRelativeUrl("Site Assets/UPLOADS-4-JOSH/FormServerTemplates")
     .files.add(fileName, file, true)
     .then((data) => {
       alert("File uploaded sucessfully");
     })
     .catch((error) => {
       alert("Error uploading file");
     });

     return;
*/
//var url = this.props.context.pageContext.web.absoluteUrl+`/_api/web/lists/GetByTitle('Site Assets')/rootfolder/Files/Add(url='{fileName}', overwrite=true)"`,
//var url = this.props.context.pageContext.web.absoluteUrl+`/SiteAssets/New-File-Upload.txt`;
  //this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report User List')/items?$filter=UserID eq '${id0}'&$orderBy=Department,ReportType desc&$top=1000`,
   
  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Site Assets')/items?&$top=1000`,
  SPHttpClient.configurations.v1, {
      headers: {
   //     Authorization: "Bearer" + accessToken
        'Accept': 'application/json;odata=nometadata',
        'Content-type': 'application/json;odata=nometadata',
        'odata-version': ''
      }
    })
      .then((response: SPHttpClientResponse) => {
        if (response.ok) {
          response.json().then((responseJSON) => {
            console.log(responseJSON);
            var html = '';
            responseJSON.value.map((item: any, index: any) => {
              html += `${item.Title}`;      
        //     ctr1++;
             });
            alert(`Item created successfully with ID: ${html}`);
            (document.getElementById("MSG1")  as HTMLInputElement).value = `Data was Saved`;
          });
        } else {
          response.json().then((responseJSON) => {
            console.log(responseJSON);
            alert(`Create: Something went wrong! Check the error in the browser console.`);
          });
        }
      }).catch(error => {
        console.log(error);
      });
     
   
 }

 
private readBLOB  = (): void => {

 var inAPI = '43';
 var inParms  = `&in0=bwmmis1-ssica.com-101222-2023-9-1-16:21:49.txt`;

//alert("BOB:" + inAPI + ' ' + inParms);

this.props.context.spHttpClient.get(`https://ssi-node-api-001.azurewebsites.net/app001?&rpt=${inAPI}${inParms}`,
SPHttpClient.configurations.v1,
{
  headers: {
    'Accept': 'application/json;odata=nometadata',
    'odata-version': ''
  }
})
//fetch('https://ssi-node-api-001.azurewebsites.net/app002',{
//  method: 'POST',
//  body: JSON.stringify({ rpt: 43, in0: 1 }),
//  headers: {"Content-Type": "application/json"}
//})
.then(function(response){
  if (response.ok) {
  alert("Response")
  response.json().then((responseJSON) => {
    var ctr1 = 0;
    let html = `<table><tr><th colspan=5>MySQL API Call</th></tr>`;
    
    if (responseJSON.length == 0) { 
        alert("EMPTY");
        document.getElementById("allItems").innerHTML = "No Data Found.";
        return;
      } 
  //  var data=responseJSON;
  //  var data1 = (data[2].pd);
  //  console.log('DATA-REF:' + data1);
  //  alert("HI:" + data)
 
       var i=0;
       for (i = 0; i < responseJSON.length; i++) { 

         var outFileName = responseJSON[i].file_name;
         var outFileData = responseJSON[i].file_data;
      //    html += "<td>"+responseJSON[i].end1;
      //    html += "<tr><td>Phone </td><td>"+responseJSON[0][0].ffdphnb;        

         ctr1++;
      };

      const Buffer = require('buffer').Buffer;
      const binaryData = Buffer.from(outFileData, 'base64');

      alert("FILE:" + outFileName)
      var hiddenElement = document.createElement('a');  
      hiddenElement.href = 'data:text/txt;charset=utf-8,' + encodeURI(binaryData);  
      hiddenElement.target = '_blank';  
        
               //provide the name for the CSV file to be downloaded  
      hiddenElement.download = outFileName;  
      hiddenElement.click();  

    html += `<tr><td colSpan=2>Number of Records:</td><td> ${ctr1} </td><tr>`;
    html += `</table>`;
    document.getElementById("allItems").innerHTML = html;
  //  alert('HTML:' + html);
    console.log(responseJSON);
  });
}
  else {
    alert(`Status code: ${response.status}` +  `${response.statusText}`);
  }
  return;
  //return response.json()

}).then(function(body){
  console.log(body);
 // alert("BODY:" + body);
});


 }

/*


  
// Delete Item
private deleteItem = (i: any): void => {

  const id: number = parseInt(i);

  if (id > 0) {
    this.props.context.spHttpClient.post(`${this.props.context.pageContext.web.absoluteUrl}/_api/web/lists/getbytitle('ReportUserList')/items(${id})`,
      SPHttpClient.configurations.v1,
      {
        headers: {
          'Accept': 'application/json;odata=nometadata',
          'Content-type': 'application/json;odata=verbose',
          'odata-version': '',
          'IF-MATCH': '*',
          'X-HTTP-Method': 'DELETE'
        }
      })
      .then((response: SPHttpClientResponse) => {
        if (response.ok) {
        //  alert(`Items deleted successfully!`);
        //  (document.getElementById("MSG1")  as HTMLInputElement).value = `Items: deleted successfully!`;
        }
        else {
          alert(`CRUD. DeleteItem Something went wrong!`);
          console.log(response.json());
        }
      });
  }
  else {
    alert(`Please enter a valid item id.`);
  } 
}
*/

/*
// Update Item
private updateItem = (id: any,url: any): void => {
  
    //  const id: number = parseInt(id1);

      const body: string = JSON.stringify({
        'URL': `${url}`
       });
      if (id > 0) {
        this.props.context.spHttpClient.post(`${this.props.context.pageContext.web.absoluteUrl}/_api/web/lists/getbytitle('Report Master List')/items(${id})`,
          SPHttpClient.configurations.v1,
          {
            headers: {
              'Accept': 'application/json;odata=nometadata',
              'Content-type': 'application/json;odata=nometadata',
              'odata-version': '',
              'IF-MATCH': '*',
              'X-HTTP-Method': 'MERGE'
            },
            body: body
          })
        .then((response: SPHttpClientResponse) => {
          if (response.ok) {
            response.json().then((responseJSON) => {
              console.log(responseJSON);
             // alert(`Item created successfully with ID: ${responseJSON.ID}`);
              (document.getElementById("MSG1")  as HTMLInputElement).value = `Data was Saved`;
            });
          } else {
            response.json().then((responseJSON) => {
              console.log(responseJSON);
              alert(`Create: Something went wrong! Check the error in the browser console.`);
            });
          }
        }).catch(error => {
          console.log(error);
        });
      }
   }
*/
  
/*
// Reset
private ResetScreen = (): void => {

    let html = ``;
    document.getElementById("allItems").innerHTML = html;
    (document.getElementById("ddSYS")  as HTMLInputElement).value = 'ALL';
    (document.getElementById("ddRPT")  as HTMLInputElement).value = 'ALL';
    (document.getElementById("ddLIST")  as HTMLInputElement).value = '0';
    (document.getElementById("MSG1")  as HTMLInputElement).value = 'Select a Department to Display the List of Available Reports';

    this.getDate();
    this.getDropDown1();
    this.getDropDown2();
    this.getDropDown3('');
   // 
   (document.getElementById("tdB1")  as HTMLInputElement).style.visibility = 'hidden';
   (document.getElementById("tdB2")  as HTMLInputElement).style.visibility = 'hidden';
   (document.getElementById("tdW1")  as HTMLInputElement).style.visibility = 'hidden';
   (document.getElementById("tdW2")  as HTMLInputElement).style.visibility = 'hidden';
}
*/
/*
// Create Item
 private insertAuditTrail = (): void => {
    const inID: string = this.props.context.pageContext.user.loginName;
    const inName: string = this.props.context.pageContext.user.displayName;
    let inID2 = `${inID}`;
    let inName2 = `${inName}`;
    var e = (document.getElementById("ddLIST") as HTMLSelectElement);
    let inLIST = e.options[e.selectedIndex].value;
    let inTitle =  e.options[e.selectedIndex].text;
    const myArray = inLIST.split('~');
    let inDept = myArray[0];
    let inType = myArray[1];
    let inURL  = myArray[2];

    let inDate = (document.getElementById("inDate")  as HTMLInputElement).value; 
  
    if (inURL.indexOf('${Buyer}') !== -1) {      
      var e = (document.getElementById("ddBUYER") as HTMLSelectElement);
      var inBUYER = e.options[e.selectedIndex].value;
    } else {
      var inBUYER = '';
    }
    if (inURL.indexOf('${Warehouse}') !== -1) {
      var e = (document.getElementById("ddWHSE") as HTMLSelectElement);
      var inWHSE = e.options[e.selectedIndex].value;
    } else {
      var inWHSE = '';
    }

   // let today = new Date();
   // let date = today.getFullYear()+'-'+(today.getMonth()+1)+'-'+today.getDate();
   // let time = today.getHours() + ":" + today.getMinutes() + ":" + today.getSeconds();
   // let inDateTime = date+' '+time;
   // inDateTime = '11-29-2017 02:19 AM';
    //alert('AuditTrail: ' + inID2 + '\n' + inName2 + '\n' + inLIST + '\n' + inTitle + '\n' + inDept + '\n' + inType + '\n' + inDate + '\n' + inBUYER + '\n' + inWHSE + '\n' + inDateTime);
 
     const body: string = JSON.stringify({
       'Title': inTitle,
       'UserID': inID2,
       'UserName': inName2, 
       'Department': inDept,
       'ReportType': inType,
       'ReportDate': inDate,
       'Buyer': inBUYER,
       'Warehouse': inWHSE
       /*
       'ReprtyDate': inDateTime
       

     });
     this.props.context.spHttpClient.post(`${this.props.context.pageContext.web.absoluteUrl}/_api/web/lists/getbytitle('ZZZ AUDIT TRAIL')/items`,
       SPHttpClient.configurations.v1, {
       headers: {
         'Accept': 'application/json;odata=nometadata',
         'Content-type': 'application/json;odata=nometadata',
         'odata-version': ''
       },
       body: body
     })
       .then((response: SPHttpClientResponse) => {
         if (response.ok) {
           response.json().then((responseJSON) => {
             console.log(responseJSON);
            // alert(`Item created successfully with ID: ${responseJSON.ID}`);
          //   (document.getElementById("MSG1")  as HTMLInputElement).value = `Data was Saved`;
           });
         } else {
           response.json().then((responseJSON) => {
             console.log(responseJSON);
             alert(`Create: Something went wrong! Check the error in the browser console.`);
           });
         }
       }).catch(error => {
         console.log(error);
       });
        
}

*/

/*  
  // Process Changes
  private processNew = (): void => {

   //return;

    let ID001 = (document.getElementById("CTR1")  as HTMLInputElement).value;
    let CTRx = 0;
    CTRx = parseInt(ID001);

    let i = 0;
  
    do { 
       // bob
       //  let ID   = (document.getElementById('ID'+i)  as HTMLInputElement).value;
       //  alert("CREATE:" + ID)
         this.createItem(i);            
      
      i++;
      } 
      while (i < CTRx && i != 999);

      (document.getElementById("MSG1")  as HTMLInputElement).value = `Data was Saved`;
};
*/


/*
 // COPY
  private insertNew = (): void => {

    this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('Report Master List')/items?&$orderBy=ID&$top=999`,
  //  this.props.context.spHttpClient.get(this.props.context.pageContext.web.absoluteUrl + `/_api/web/lists/getbytitle('ZAP_FISCAL_CALENDAR')/items?$top=999`, $filter=SplitBy eq 'CHAIN'
   
    SPHttpClient.configurations.v1,
    {
      headers: {
        'Accept': 'application/json;odata=nometadata',
        'odata-version': ''
      }
    })
    .then((response: SPHttpClientResponse) => {
      if (response.ok) {
        response.json().then((responseJSON) => {
          let ctr1 = 0;
          let html = ` <table className={styles.tb1}><tr><th colspan=2>List of Available Reports</th></tr><tr>`;

          responseJSON.value.map((item: any, index: any) => {
      
            html += `<tr><td><input type="checkbox" id="cbX${item.ID}"></td><td>${item.Title}`;
            html += `<input type="hidden" id="cbO${item.ID}" value="false">`;
            html += `<input type="hidden" id="IDO${item.ID}" value="">`;
            html += `<input type="text" id="ID${ctr1}" value="${item.ID}">`;
            html += `<input type="text" id="Title${item.ID}" value="${item.Title}">`;
            html += `<input type="text" id="ReportType${item.ID}" value="${item.ReportType}">`;
            html += `<input type="text" id="Department${item.ID}" value="${item.Department}">`;
            html += `<tr><td><input type="text" id="ReportID${item.ID}" value="${item.ReportID}">`;
            html += `<input type="text" id="JobName${item.ID}" value="${item.JobName}">`;
            html += `<input type="text" id="URL1${item.ID}" value="${item.URL}">`;
            html += `<input type="text" id="SplitBy${item.ID}" value="${item.SplitBy}">`;
            html += `<input type="text" id="Active${item.ID}" value="${item.Active}">`;
            ctr1++;
           
          });
          html += `</table><p><input type="text" id=CTR1 value='${ctr1}'>`;
          document.getElementById("allItems").innerHTML = html;
          alert('HTML:' + html);
          console.log(responseJSON);
     
          let MSGOK = (document.getElementById("MSG1")  as HTMLInputElement).value;
          if (MSGOK != 'Data was Saved') { 
            (document.getElementById("MSG1")  as HTMLInputElement).value = `Select/Unselect Reports and Click on 'Save' to process.`;
          }
        }).then(() => this.processNew());;
      } else {
        response.json().then((responseJSON) => {
          console.log(responseJSON);
          alert(`Something went wrong! Check the error in the browser console.`);
        });
      }
    }).catch(error => {
      console.log(error);
    });
  }
 */

  /*
  // Create Item
  private createNew = (i: any): void => {

    let ID   = (document.getElementById('ID'+i)  as HTMLInputElement).value;
 
 //   let ID1 = (document.getElementById('ID'+i)  as HTMLInputElement).value;
 //   let ID2 = (document.getElementById('REPORT'+ID)  as HTMLInputElement).value;
 //   let ID3 = (document.getElementById('SystemID'+ID)  as HTMLInputElement).value;
 //   let ID4 = (document.getElementById('ReportType'+ID)  as HTMLInputElement).value;
 //   alert('Create: ' + ID + '\n' + ID1 + '\n' + ID2 + '\n' + ID3 + '\n' + ID4);
 
     const body: string = JSON.stringify({
       'Title': (document.getElementById('REPORT'+ID)  as HTMLInputElement).value,
       'ReportType': (document.getElementById('ReportType'+ID)  as HTMLInputElement).value,
       'Department': (document.getElementById('SystemID'+ID)  as HTMLInputElement).value,
       'ReportID': (document.getElementById('ReportID'+ID)  as HTMLInputElement).value,  
       'JobName': (document.getElementById('JobName'+ID)  as HTMLInputElement).value, 
       'URL': (document.getElementById('URL1'+ID)  as HTMLInputElement).value, 
       'SplitBy': (document.getElementById('SplitBy'+ID)  as HTMLInputElement).value

     });
     this.props.context.spHttpClient.post(`${this.props.context.pageContext.web.absoluteUrl}/_api/web/lists/getbytitle('temp Report Master List')/items`,
       SPHttpClient.configurations.v1, {
       headers: {
         'Accept': 'application/json;odata=nometadata',
         'Content-type': 'application/json;odata=nometadata',
         'odata-version': ''
       },
       body: body
     })
       .then((response: SPHttpClientResponse) => {
         if (response.ok) {
           response.json().then((responseJSON) => {
             console.log(responseJSON);
            // alert(`Item created successfully with ID: ${responseJSON.ID}`);
             (document.getElementById("MSG1")  as HTMLInputElement).value = `Data was Saved`;
           });
         } else {
           response.json().then((responseJSON) => {
             console.log(responseJSON);
             alert(`Create: Something went wrong! Check the error in the browser console.`);
           });
         }
       }).catch(error => {
         console.log(error);
       });
    
  }
 */
}